--Text System Initialize v0.2
--This script initializes the text system, please don't edit.
--Change Log:
--0.1 - First release
--0.2 - Modified the galpsp_print() code in order to improve speed.
--    - Changed galpsp_print() by using coroutines.

--Funtions
function galpsp_print(text,color,cont,wait)
	temp_enable("text")
	if wait == nil then
		wait = 3
	end
	cur = 0 --Cursor Position (x)
	line = startline --Cursor Position (y)
	colm = 0 --Relative Column (From line start to cursor)
	colp = 1 --Absolute Column (From string start to cursor)
	textw:clear()
	if beep_voice == true then
		soundt = Sound.load("./Data/Sound/bip.wav")
	end
	for w in string.gfind(text, ".") do
		if beep_voice == true then
			soundt:play()
		end
		textw:print((colm*8)+offsetx,line,w,color)
		galpsp_render()
		colm = colm + 1
		colp = colp + 1
		if colm >= maxcol then
			line = line + 10
			if line >= maxlines then
				local conf = false
				while conf == false do
					conf = press_a()
				end
				textw:clear()
				line = startline
			end
			colm = 0
		end
		local keyin = Controls.read()
		if not keyin:cross() and wait ~= 0 then
			screen.waitVblankStart(wait)
		end
	end
	screen.waitVblankStart(25)
	if cont ~= false then
		press_a()
	end
	temp_disable()
end

function galpsp_showname(charID)
	namew:clear()
	namew:print(0,0,displayname[charID],speechcolor[charID])
end

function galpsp_speech(charID,text,cont)
	if cont == nil then
		cont = true
	end
	myID = getID(charID)
	galpsp_showname(myID)
	galpsp_print(text,speechcolor[myID],cont)
end

--Options System
function galpsp_showoptions(colorp,optioncolor)
	screen.waitVblankStart(25)
	namew:clear()
	textw:clear()
	opti = {}
	local yarg = 15
	selopt = nil
	--Draw Phase
	for i=1,5,1 do
		if optl[i][1] == 0 then
			break
		end
		if optl[i][2] ~= 0 then
			textw:print(offsetx+20,yarg,optl[i][1],colorp)
			yarg = yarg + 10
			table.insert(opti,i)
			galpsp_render()
		end
	end
	--Option Select Phase
	optionw_visible = true
	local noptions = table.getn(opti)
	local hiloption = 1
	while selopt == nil do
		local keyin = Controls.read()
		if keyin:up() or keyin:analogY() <= -100 then
			hiloption = hiloption - 1
			if hiloption <= 0 then
				hiloption = noptions
			end
		end
		if keyin:down() or keyin:analogY() >= 100 then
			hiloption = hiloption + 1
			if hiloption > noptions then
				hiloption = 1
			end
		end
		if keyin:cross() then
			selopt = hiloption
		end
		optionw:clear()
		optionw:fillRect(10,10*hiloption,330,10,optioncolor)
		galpsp_render()
		screen.waitVblankStart(7)
	end
	--Deinit
	optionw:clear()
	selopt = opti[selopt]
	for i=1,noptions,1 do
		table.remove(opti)
	end
	textw:clear()
	optionw_visible = false
	return selopt
end

function galpsp_option(optn,theText,vi)
	if vi == true then
		vi = 1
	end
	if vi == false then
		vi = 0
	end
	if optn > 5 or vi > 1 then
		error("Bad option argument")
	end
	optl[optn][1]=theText
	optl[optn][2]=vi
end

function galpsp_initoption()
	win = Image.createEmpty(480,272)
	opt1 = {0,0}
	opt2 = {0,0}
	opt3 = {0,0}
	opt4 = {0,0}
	opt5 = {0,0}
	optl = {opt1,opt2,opt3,opt4,opt5}
	opti = {}
end
function galpsp_optionvisible(optn)
	if optl[optn][2] == 0 then
		vi = 1
	else
		vi = 0
	end	
	optl[optn][2]=vi
	return vi
end
--EOF