--Courtroom Prefab 0.1 by Karurosu
--Designed for GALSPS 0.2+
--Permission given to copy and modify.

--Variables
local curr_view = 0

--Functions
function prefab_initcourtroom()
	--Load Courtroom Background
	cr_bg1 = Image.load("./Data/GFX/Courtroom/bg1.png")
	cr_bg2 = Image.load("./Data/GFX/Courtroom/bg2.png")
	cr_judgebg = Image.load("./Data/GFX/Courtroom/judge_bg.png")
	cr_witbg = Image.load("./Data/GFX/Courtroom/wit_bg.png")
	cr_life = Image.load("./Data/GFX/Courtroom/life.png")
	cr_pressb = Image.load("./Data/GFX/System/press_b.png")
	cr_presentb = Image.load("./Data/GFX/System/present_b.png")
	cr_points = 5
	--This function checks for a blank character, if there is not one, it will ad one
	local found = nil
	table.foreachi(ID, function(k,v)
							if v == "blank" then
								found = true
							end
						end )
	if found ~= true then
		table.insert(ID,"blank")
		table.insert(speechcolor,yellow)
		table.insert(displayname,"")
	end
end
function cr_deinit()
	cr_bg1 = nil
	cr_bg2 = nil
	cr_judgebg = nil
	cr_witbg = nil
	cr_points = nil
	galpsp_out()
	collectgarbage()
end
function person2number(person)
	if person == "defense" or person == "dfs" then
		return 1
	end
	if person == "prosecution" or person == "pro" then
		return 2
	end
	if person == "judge" or person == "jud" then
		return 3
	end
	if person == "witness" or person == "wit" then
		return 4
	end
	if person == "defendant" or person == "dfd" then
		return 5
	end
	if person == "extra" or person == "ext" then
		return 6
	end
	if person =="off" then
		return person
	end
end
function cr_show(person,force)
	if type(person) == "string" then
		person = person2number(person)
	end
	if person == 6 then
		person = 1
	end
	if curr_view ~= person or force == true then
		textw:clear()
		centerw:clear()
		namew:clear()
		leftw:clear()
		rightw:clear()
		if person == 1 or person == 6 then
			galpsp_changebg(cr_bg1)
			curr_view = person
			galpsp_drawchar(courtroom_def_gfx[1],center)
			galpsp_drawchar(courtroom_def_gfx[6],left)
			positionID = { 1,0,1 }
			galpsp_render()
			--print("defense")
		end
		if person == 2 then
			galpsp_changebg(cr_bg2)
			curr_view = person
			galpsp_drawchar(courtroom_def_gfx[2],center)
			positionID = { 0,0,1 }
			galpsp_render()
			--print("prosecution")
		end
		if person == 3 then
			galpsp_changebg(cr_judgebg)
			curr_view = person
			galpsp_drawchar(courtroom_def_gfx[3],center)
			positionID = { 0,0,1 }
			galpsp_render()
			--print("judge")
		end		
		if person == 4 then
			galpsp_changebg(cr_witbg)
			curr_view = person
			galpsp_drawchar(courtroom_def_gfx[4],center)
			positionID = { 0,0,1 }
			galpsp_render()
			--print("witness")
		end		
		if person == 5 then
			galpsp_changebg(cr_witbg)
			curr_view = person
			galpsp_drawchar(courtroom_def_gfx[5],center)
			positionID = { 0,0,1 }
			galpsp_render()
			--print("defendant")
		end
	end
end

function cr_objection()
		objt = Image.load("./Data/GFX/Courtroom/objection.png")
		screen:clear()
		screen:blit(0,0,objt)
		screen.flip()
		wait(1)
		objt = nil
end
function cr_speak(person,speech,focus,cont)
	if person ~= "off" then
		if focus == true or focus == nil then
			cr_show(person)
		end
		if type(person) == "string" then
			person = person2number(person)
		end
		galpsp_speech(courtroom_chars[person],speech,cont)
	else
		galpsp_speech("blank",speech,cont)
	end
end
	
function cr_change(person, ngfx)
	if type(person) == "string" then
		person = person2number(person)
	end
	courtroom_def_gfx[person] = ngfx
	cr_show(person,true)
end

function cr_exam(examfile)
	objt = Image.load("./Data/GFX/Courtroom/witnesstest.png")
	screen:clear()
	screen:blit(0,0,objt)
	screen.flip()
	wait(1)
	objt = nil
	exam_file = io.open("./Data/Scripts/"..examfile..".csf","r")
	currdialog = 1
	--Load total dialog options:
	exam_file:seek("set")
	for line in exam_file:lines() do
		if string.sub(line,0,2) == "h@" then
			maxdialog = tonumber(string.sub(line,3,3))
			break
		end
	end
	cr_drawtext(1)
	while command ~= "kill" do
		cr_drawlife()
		local keyin = Controls.read()
		if keyin:left() and (currdialog-1) > 0 then
			currdialog = currdialog-1
			cr_drawtext(currdialog)
		end
		if keyin:right() and (currdialog+1) <= (maxdialog+1) then
			if currdialog == maxdialog then
				currdialog = 1
				cr_exec("e")
				cr_drawtext(currdialog)
			else
				currdialog = currdialog+1
				cr_drawtext(currdialog)
			end
		end
		if keyin:l() then
			command = cr_exec("p"..tostring(currdialog))
			if command == "kill" then
				return
			end
			cr_drawtext(currdialog)
		end
		if keyin:r() then
			local sel = inv_show()
			if sel ~= nil then
				exam_file:seek("set")
				for line in exam_file:lines() do
					if string.sub(line,1,3) == "r"..tostring(currdialog).."@" then
						myline = line
						break
					end
				end
				if sel == string.sub(myline,4,string.len(myline)-1) then
					command = cr_exec("r"..tostring(currdialog))
					if command == "kill" then
						return
					end
				else
					cr_losepoint()
				end
			end
			cr_drawtext(currdialog)
		end
		screen.waitVblankStart(2)
	end
end

function cr_drawlife()
	if table.getn(object_x) == 0 then
	for i=1,cr_points,1 do
		galpsp_insobj((i*20)-20,252,cr_life,true)
	end
	galpsp_insobj(0,0,cr_pressb,true)
	galpsp_insobj(430,0,cr_presentb,true)
	end
end

function cr_losepoint()
	dofile("./Data/Scripts/loselife.lua")
	cr_points = cr_points -1
	if cr_points <= 0 then
		dofile("./Data/Scripts/gameover.lua")
	end
	cr_drawtext(currdialog)
end 

function cr_exec(header)
	local tow = 3
	if header == "e" then
		tow = 2
	end
	exam_file:seek("set")
	for line in exam_file:lines() do
		if string.sub(line,1,tow) == header.."@" then
			break
		end
	end
	while true do
		parsest = exam_file:read("*l")
		if string.sub(parsest,1,2) == "@t" then
			local chara = person2number(string.sub(parsest,4,6))
			cr_speak(chara, string.sub(parsest,8,string.len(parsest)-1))
		end
		if string.sub(parsest,1,string.len(parsest)-1) == "@exit" then
			return "kill"
		end
		if string.sub(parsest,1,2) == "@/" then
			return
		end
		if string.sub(parsest,1,2) == "@w" then
			wait(tonumber(string.sub(parsest,4,string.len(parsest)-1)))
		end
		if string.sub(parsest,1,2) == "@c" then
			local chara = person2number(string.sub(parsest,4,6))
			cr_change(chara, string.sub(parsest,8,string.len(parsest)-1))			
		end
		if string.sub(parsest,1,2) == "@s" then
			galpsp_insobj(10,30,inv_getgfx(string.sub(parsest,4,string.len(parsest)-1)),true)
		end
		if string.sub(parsest,1,2) == "@h" then
			galpsp_clearObj()
			galpsp_render()
		end
		if string.sub(parsest,1,2) == "@f" then
			dofile("./Data/Scripts/"..string.sub(parsest,4,string.len(parsest)-1))
		end
		if string.sub(parsest,1,2) == "@a" then
			inv_add(string.sub(parsest,4,string.len(parsest)-1))
		end
		if string.sub(parsest,1,2) == "@r" then
			inv_rm(string.sub(parsest,4,string.len(parsest)-1))
		end
	end
end

function cr_drawtext(numbert)
	exam_file:seek("set")
	if numbert > maxdialog then
		error("Dialog Does not exist")
	end
	for line in exam_file:lines() do
		if string.sub(line,1,3) == "d"..tostring(numbert).."@" then
			string_ts = string.sub(line,4,string.len(line)-1)
			break
		end
	end
	cr_speak("witness",	string_ts, true, false)
end
