--System Functions Initialize v0.2
--This script initializes the functions related to the system

--Changelog
--0.1 - Initial release
--0.2 - Added Version Check

--Variables
tchar = ""
IDr = nil
galpsp_ver_maj = "0.200"
galpsp_ver_min = "f"
galpsp_ver_dist = "PSP-LUA"

--Functions
function galpsp_versioncheck(major,minor,dist)
	curmaj = tonumber(galpsp_ver_maj)
	if dist ~= galpsp_ver_dist and dist ~= "a" then
		error("The distribution is not correct. Needed:"..galpsp_ver_dist.." Prefab Version:"..dist)
	end
	if type(major) == "string" then
		major = curmaj
	end 
	if curmaj < major then
 	error("This prefab needs GALPSP version "..galpsp_ver_maj.." Prefab version is "..major)
	end
end
function press_a(anim)
	local conf = false 
	blink_currframe = 0
	while conf == false do
		local keyin = Controls.read()
		if keyin:cross() then
			blink:clear()
			return
		end
		if anim == nil or anim == "true" then
			blink_currframe=math.mod(blink_currframe+1,blink_frames)+1
			if temp_image == false then
				blink:clear()
				blink:blit(0,0, blink_gfx, blink_currframe*blink_width-blink_width,0,blink_width,blink_gfx:height(), true)
				screen.waitVblankStart(7)
				galpsp_render()
			else
				galpsp_render(false)
				screen:blit(440,230, blink_gfx, blink_currframe*blink_width-blink_width,0,blink_width,blink_gfx:height(), true)
				screen.flip()
			end
		end
	end
end

function indexpos(pos)
	if pos == "left" then
		indexer2 = 1
	end
	if pos == "center" then
		indexer2 = 3
	end
	if pos == "right" then
		indexer2 = 2
	end
	return indexer2
end

function getID(chara)
	tchar = chara
	IDr = nil
	typen = type(chara)
	if typen == "string" then
		table.foreachi(ID, checky)
	end
	if typen == "number" then
		IDr = chara
	end
	if IDr == nil then
		error("Character does not exist")
		IDr = 1
	end
	return IDr
end


function checky(v,k)
	if ID[v] == tchar then
		IDr = v
	else
		return nil
	end
end

function sec2mil(sec)
	local mils = sec*1000
	return mils
end

function wait(seconds)
	conti = false
	mytimer1 = Timer.new()
	mytimer1:start()
	while mytimer1:time() <= (seconds*1000) do
		--galpsp_render()
		screen.waitVblankStart(1)
	end
	mytimer1:stop()
	mytimer1 = nil
end

function debug_locate()
	screen.waitVblankStart(20)
	sizex = 1
	sizey = 1
	dedox = 20
	dedoy = 20
	debugw:clear()
	debug_visible= true
	ultracoso = true
	while ultracoso == true do
		screen:clear()
		debugw:clear()
		local keyin = Controls.read() --Lee los controles
		if keyin:down() then --Si esta presionado hacia abajo
			dedoy = dedoy + 5 --Cambia la posicion de dedoy en 17
		end
		if keyin:up() then --Si esta presionado hacia abajo
			dedoy = dedoy - 5 --Cambia la posicion de dedoy en 17
		end
		if keyin:right() then --Si esta presionado hacia abajo
			dedox = dedox + 5 --Cambia la posicion de dedox en 17
		end
		if keyin:left() then --Si esta presionado hacia abajo
			dedox = dedox - 5 --Cambia la posicion de dedox en 17
		end
		if keyin:analogX() >= 100 then
			sizex = sizex + 5
		end
		if keyin:analogX() <= -100 then
			sizex = sizex - 5
		end
		if keyin:analogY() >= 100 then
			sizey = sizey + 5
		end
		if keyin:analogY() <= -100 then
			sizey = sizey - 5
		end
		if keyin:cross() then
			return
		end
		debugw:fillRect(dedox,dedoy,sizex,sizey,Color.new(255,255,255))
		debugw:print(0,0,dedox,Color.new(255,255,255))
		debugw:print(0,10,dedoy,Color.new(255,255,255))
		debugw:print(50,0,sizex,Color.new(255,255,255))
		debugw:print(50,10,sizey,Color.new(255,255,255))
		screen.waitVblankStart()
		galpsp_render()
		end	
end

--Save & load functions
function galpsp_save(tablesav,savefil)
	file = io.open(savefil, "w")
	if file then
		for key, value in tablesav do
			file:write(value.."\n")
		end
		file:close()
	end
end

function galpsp_load(tableload,savefil)
	file = io.open(savefil, "r")
	if file then
		for line in file:lines() do
			table.insert(tableload,line)
		end
		file:close()
	end
end

function number2savefile(numbers)
	local savefil = "./Save/sav"..tostring(numbers)..".sav"
	return savefil
end

--EOF