--Inventory Prefab 0.1 by Karurosu
--Permission give to copy or modify

inv_file = "./Data/Scripts/inventory.inv"
inv_bg = ""


function prefab_initinv()
	inv_table = {}
	inv_db = io.open(inv_file,"r")
	select_img = Image.load("./Data/GFX/System/Select.png")
	cancel_b = Image.load("./Data/GFX/System/cancel_b.png")
	present_b = Image.load("./Data/GFX/System/present_b.png")
end

function inv_add(ID)
	table.insert(inv_table,ID)
end

function inv_rm(ID)
	table.foreachi(inv_table, function(k,v)
								if v == ID then
									table.remove(inv_table,k)
									return
								end
							  end
				  )
end

function inv_getpos(ID)
	local ID_ret = nil
	table.foreachi(inv_table, function(k,v)
								if v == ID then
									ID_ret = k
									return
								end
							end
					)
	return ID_ret
end

function inv_getgfx(ID)
	inv_db:seek("set")
	for line in inv_db:lines() do
		if string.sub(line,0,string.len(line)-1) == ID then
			break
		end
	end
	local gfx_r = inv_db:read("*l")
	return string.sub(gfx_r,2,string.len(gfx_r)-1)
end

function inv_getdes(ID)
	inv_db:seek("set")
	for line in inv_db:lines() do
		if string.sub(line,0,string.len(line)-1) == ID then
			break
		end
	end
	inv_db:read("*l")
	local des_r = inv_db:read("*l")
	return string.sub(des_r,2,string.len(des_r)-1)
end		

function inv_show()
	screen:clear()
	galpsp_clearObj()
	left_visible = false
	right_visible = false
	center_visible = false
	--------------------
	sel_off = 1
	start_im = 1
	local cont = false
	inv_draw(start_im,sel_off)
	local sel_t = 0
	local start_t = 0
	while cont == false do
		local keyin = Controls.read()
		if keyin:left() then
			sel_t = sel_off - 1
			start_t = start_im - 4
			if sel_t <= 0 and start_t >= 1 then
				sel_off = 4
				start_im = start_im - 4
				inv_draw(start_im,sel_off)
			end
			if sel_t >= 1 then
				sel_off = sel_off - 1
				inv_draw(start_im,sel_off)
			end
		end
		if keyin:right() then
			sel_t = sel_off + 1
			start_t = start_im + 4
			if sel_t == 5 and start_t <= table.getn(inv_table) then
				sel_off = 1
				start_im = start_im + 4
				inv_draw(start_im,sel_off)
			end
			if sel_t <= 4 and (sel_t + start_im -1) <= table.getn(inv_table) then
				sel_off = sel_off + 1
				inv_draw(start_im,sel_off)
			end
		end
		if keyin:l() then
			screen.waitVblankStart(8)
			galpsp_clearObj()
			galpsp_render()
			left_visible = true
			right_visible = true
			center_visible = true
			return nil
		end
		if keyin:r() then
			screen.waitVblankStart(8)
			galpsp_clearObj()
			galpsp_render()
			left_visible = true
			right_visible = true
			center_visible = true
			return inv_table[start_im+sel_off-1]
		end
	end
end

function inv_draw(startoff,selpos)
	screen.waitVblankStart(8)
	galpsp_clearObj()
	screen:clear()
	local selx = 0
	if selpos == 1 then
		selx = 5
	end
	if selpos == 2 then
		selx = 125
	end
	if selpos == 3 then
		selx = 245
	end
	if selpos == 4 then
		selx = 365
	end
	
	galpsp_insobj(selx,25,select_img,true)
	local ix = 10
	for n = 0,3,1 do
		if type(inv_table[startoff+n]) ~= "nil" then
			galpsp_insobj(ix,30,inv_getgfx(inv_table[startoff+n]),true)
			ix = ix + 120
		end
	end
	galpsp_insobj(0,0,cancel_b,true)
	galpsp_insobj(430,0,present_b,true)
	namew:clear()
	namew:print(0,0,inv_table[startoff+selpos-1],yellow)
	inv_printdes(startoff+selpos-1)
end

function inv_printdes(position)
	cur = 0 --Cursor Position (x)
	line = startline --Cursor Position (y)
	colm = 0 --Relative Column (From line start to cursor)
	colp = 1 --Absolute Column (From string start to cursor)
	textw:clear()
	for w in string.gfind(inv_getdes(inv_table[position]), ".") do
		textw:print((colm*8)+offsetx,line,w,yellow)
		galpsp_render()
		colm = colm + 1
		colp = colp + 1
		if colm >= maxcol then
			line = line + 10
			if line >= maxlines then
				local conf = false
				while conf == false do
					conf = press_a()
				end
				textw:clear()
				line = startline
			end
			colm = 0
		end
		local keyin = Controls.read()
		if keyin:left() or keyin:right() then
			return
		end
	end
	screen.waitVblankStart(8)
end
	